function drawSnakeRobot_plotpurposes(theta, p, link_color)
%
% Draws the snake robot in a graph window.
%

global n l sin_theta_diag cos_theta_diag


% Calculates diagonal matrices that are used in the proceeding calculations
sin_theta_diag = calculate_sin_theta_diag(theta);
cos_theta_diag = calculate_cos_theta_diag(theta);

% Calculates link positions.
z = calculate_z(theta, [], p);

% Extracts the x and y coordinates
x = z(1:n, 1);
y = z(n+1:2*n, 1);
th = theta(:, 1);

% Draws the snake robot
for j = 1:n
    % Calculates the global frame coordinates of the
    % beginning of the next link
    startx = x(j, 1) - l*cos(th(j, 1));
    starty = y(j, 1) - l*sin(th(j, 1));
    % Calculates the global frame coordinates of the
    % end of the next link
    endx = x(j, 1) + l*cos(th(j, 1));
    endy = y(j, 1) + l*sin(th(j, 1));
    
    % Draws the next link
    plot([startx ; endx], [starty ; endy], link_color, 'linewidth', 2)
    
end

% Close-up rectangular view
%axis([p(1,1)-n*l-0.1, p(1,1)+n*l+0.1, p(2,1)-n*l-0.1, p(2,1)+n*l+0.1]);
% Close-up flat view
%axis([p(1,1)-n*l-0.1, p(1,1)+n*l+0.1, p(2,1)-6*l, p(2,1)+6*l]);
% Zoomed out view
%axis([-0.7, 3.0, -0.4, 0.4]);
% Zoomed out view
%axis([-0.7, 1.5, -0.4, 0.4]);
