function [angrep, fxt, fyt, tau_t, delta, C_beta_psi, S_beta_psi,c_psi,s_psi, a]=Tail(z, z_dot, theta, p_CM_dot, theta_dot, S, B, b_mean)

global V_x_a V_y_a ro n l 

% %initial values
% fxt=zeros(n, 1);
% fyt=zeros(n, 1);
% tau_t=zeros(n, 1);
% Calculating a. The distance from mid cord to rotation point in semicords

if b_mean==0
    a=0;
else
a=-0.5-(l(1,1)/b_mean);
end



% Calculates a vector of squared angular link velocities
theta_dot_sq = zeros(n, 1);

for i = 1:n
    theta_dot_sq(i, 1) = theta_dot(i, 1)*theta_dot(i, 1);
end

% Calculate the forward velosity and angel (heading)
U=sqrt((p_CM_dot(1)-V_x_a(1))^2+(p_CM_dot(2)-V_y_a(1))^2);
%U=p_CM_dot(1)-V_x_a(1);
psi=atan2((p_CM_dot(2)-V_y_a(1)),(p_CM_dot(1)-V_x_a(1)));
psi=0;

%Rotation into heading frame
c_psi = cos(psi)*eye(n);
s_psi = sin(psi)*eye(n);
R = [c_psi -s_psi ; s_psi c_psi];

% Position and elosity in heading frame
xy=R*[z(1:n);z(n+1:2*n)];
xy_dot=R*[z_dot(1:n);z_dot(n+1:2*n)];

% h is the x position and velosity in heading frame
h=-xy(n+1:2*n);
h_dot=-xy_dot(n+1:2*n);

%defining delta
delta=theta-psi;
delta_dot=theta_dot;

% calculating beta
if h_dot==0 & U==0
    beta=0;
elseif delta_dot==0 & U==0
    beta=0;
else
    beta=atan(h_dot/U);%+atan(b_mean*((delta_dot)/U*(0.5-a)));
end


%calculating the lift force
L_added=pi*ro*(B.^2*U*delta_dot);
angrep=0;
if h_dot==0 & U==0
    if delta_dot<0.00001 & U==0
        L_alpha=2*pi*ro*U^2*(B*delta);
    else
        L_alpha=2*pi*ro*U^2*(B*delta+B*atan(B*(delta_dot)/U*(0.5-a)));
    end
elseif delta_dot<0.00001 & U==0
        L_alpha=2*pi*ro*U^2*(B*delta+B*atan(h_dot/U));
else
L_alpha=2*pi*ro*U^2*(B*delta+B*atan(h_dot/U)+B*atan(B*(delta_dot)/U*(0.5-a)));
angrep=delta+atan((h_dot/U))+atan(b_mean*((delta_dot)/U*(0.5-a)));
end
%L_alpha=S*2*pi*ro*U^2*(B*delta);
L=S*(L_added+L_alpha);

%Calculating the drag force on the foil
%drag friction
Cdf=zeros(n,1);
Rn=U*2*b_mean/(1*10^(-6));
Cf=0.075./log10(Rn-2)^2;
t_max=0.16*2*b_mean;
if Rn <= 1
    Cdf(1,1)=0;
else
Cdf(1,1)=2*Cf*(1+2*t_max/(2*b_mean));
end

% %Drag indused
A=S(1,1)*4*b_mean;
Asp=S(1,1)/(2*b_mean);
Cdi=zeros(n,1);
if U==0
    Cl=0;
    Cdi=zeros(n,1);
elseif Asp==0
    Cl=0;
    Cdi=zeros(n,1);
else
Cl=L_alpha./(0.5*ro*U^2);
Cdi=Cl.^2/(pi*Asp);
end

D=0.5*ro*(Cdf+Cdi)*A*U^2;
%D=zeros(n,1);

C_beta_psi=diag(cos(beta+psi));
S_beta_psi=diag(sin(beta+psi));


fxt=(S_beta_psi*L-C_beta_psi*D);
fyt=(C_beta_psi*L+S_beta_psi*D);

% calculating the moment
tau_added=-pi*ro*(B.^3*(0.5-a)*U*delta_dot);

if h_dot==0 & U==0
    if delta_dot<0.00001 & U==0
        tau_alpha=2*pi*ro*U^2*(a+0.5)*(B.^2*delta);
    else
        tau_alpha=2*pi*ro*U^2*(a+0.5)*(B.^2*delta+B.^2*atan(B*delta_dot/U*(0.5-a)));
    end
elseif delta_dot<0.00001 & U==0
        tau_alpha=2*pi*ro*U^2*(a-0.5)*(B.^2*delta+B.^2*atan(h_dot/U));
else
tau_alpha=2*pi*ro*U^2*(a+0.5)*(B.^2*delta+B.^2*atan(h_dot/U)+B.^2*atan(B*delta_dot/U*(0.5-a)));    
end
%tau_alpha=2*pi*ro*U^2*(a-0.5)*(B_2*delta);
tau_t=S*(tau_added+tau_alpha);



% int=n;
% b=c_c./2;
% h_t=h_c;
% ii=size(b);
% ii=ii(1);
% theta_dot_dot=v_dot_dot_old((n+3):2*n+2);
% p_CM_dot_dot=v_dot_dot_old((2*n+3):2*n+4);
% 

% % Linear velocities of each link in the global x direction
% x_dot_dot = K*cos_theta_diag*theta_dot_sq + K*sin_theta_diag*theta_dot_dot + e*p_CM_dot_dot(1);
% 
% % Linear velocities of each link in the global y direction
% y_dot_dot = K*sin_theta_diag*theta_dot_sq + K*cos_theta_diag*theta_dot_dot + e*p_CM_dot_dot(2);
% 
% fxt=zeros(n,1);
% fyt=zeros(n,1);
% tau_t=zeros(n,1);
    
end

