function [fx, fy] = calculate_f_drag(theta_dot, z_dot)
%
% Calculates and returns the translational friction forces on each link.
%

global n sin_theta_diag cos_theta_diag ct cn V_current

fx = zeros(n, 1);
fy = zeros(n, 1);

if 1
    
matrix1 = [ct*cos_theta_diag -cn*sin_theta_diag;
            ct*sin_theta_diag cn*cos_theta_diag];
        
matrix2 = [cos_theta_diag sin_theta_diag ;
            -sin_theta_diag cos_theta_diag];
        
matrix3 = matrix2*(z_dot-V_current);
matrix4 = abs(matrix3);
matrix5=matrix3.*matrix4;

matrix6=matrix1*matrix2;

f_linear=matrix6*(z_dot-V_current);
        
f_non_linear = matrix1*matrix5;

f=-(f_linear+f_non_linear);

% Partitions the vector
fx = f(1:n);
fy = f(n+1:2*n);

end
