function [u, phi_ref] = calculate_u_eel_undulation_test2(t, phi, phi_dot, theta, p_CM, p_CM_dot)
%
% Calculates and returns the actuator forces. This is the joint controller
% of the snake robot.
%
PS=0;
global n Kp_joint Kd_joint alpha omega delta

phi_offset = 0;

% Calculates references for joint angles.
phi_ref = zeros(n-1, 1);
for i = 1:n-2
    phi_ref(i, 1) = alpha*(n-i)/(n-1)*sin(omega*t + (i-1)*delta) - phi_offset;
    %phi_ref(i, 1) = alpha*(i)/(n-1)*sin(omega*t + (i-1)*delta) - phi_offset;

end
phi_ref(n-1, 1) = alpha*(n-(n-1))/(n-1)*sin(omega*t + ((n-PS)-1)*delta) - phi_offset;

% Calculates references for joint velocities.
phi_ref_d = zeros(n-1, 1);
for i = 1:n-2
    phi_ref_d(i, 1) = alpha*(n-i)/(n-1)*omega*cos(omega*t + (i-1)*delta);
    %phi_ref_d(i, 1) = alpha*(i)/(n-1)*omega*cos(omega*t + (i-1)*delta);

end
phi_ref_d((n-1), 1) = alpha*(n-(n-1))/(n-1)*omega*cos(omega*t + ((n-PS)-1)*delta);

% Calculates references for joint accelerations.
phi_ref_dd = zeros(n-1, 1);
for i = 1:n-2
    phi_ref_dd(i, 1) = -alpha*(n-i)/(n-1)*omega^2*sin(omega*t + (i-1)*delta);
    %phi_ref_dd(i, 1) = -alpha*(i)/(n-1)*omega^2*sin(omega*t + (i-1)*delta);

end
phi_ref_dd((n-1), 1) = -alpha*(n-(n-1))/(n-1)*omega^2*sin(omega*t + ((n-PS)-1)*delta);


% Calculates the actuator forces.
u = zeros(n-1, 1);
for i = 1:n-1
    error = phi_ref(i, 1) - phi(i, 1);
    error_d = phi_ref_d(i, 1) - phi_dot(i, 1);
    %u(i, 1) = Kp_joint*error - Kd_joint*phi_dot(i, 1);
    u(i, 1) = phi_ref_dd(i, 1) + Kd_joint*error_d + Kp_joint*error;
end


