function [phi_dot_dot, theta_dot_dot, p_CM_dot_dot] = calculate_q_dot_dot_CM(t, theta_dot, fx, fy, fxt, fyt, tau, tau_t, u)
%
% Calculates and returns the acceleration of theta and p_CM and the constraint joint forces
% for each link of the snake robot. Theta are the absolute link angles and
% p_CM is the position of the center of mass of the snake.
%

global n l J A D e E  N l_N l_N_tr V N_N_tr V_x_a V_y_a m...
sin_theta_diag cos_theta_diag  M_temp mi_n cn ct lambda1 lambda2 lambda3 m_tot K A_1 teller t_save qw

%Calculate useful matrixes
% if teller==500
%     stopp
% end
% teller=teller+1
Mtot=[m_tot+e'*mi_n*sin_theta_diag*sin_theta_diag*e -e'*mi_n*sin_theta_diag*cos_theta_diag*e;...
    -e'*mi_n*sin_theta_diag*cos_theta_diag*e m_tot+e'*mi_n*cos_theta_diag*cos_theta_diag*e;];

Mtot_inv=Mtot\eye(2);



M11=Mtot_inv(1,1); M12=Mtot_inv(1,2); M21=Mtot_inv(2,1); M22=Mtot_inv(2,2);

%N1=l*sin_theta_diag*N*mi_n*sin_theta_diag*sin_theta_diag*e+l*cos_theta_diag*N*mi_n*sin_theta_diag*cos_theta_diag*e;
%N2=l*sin_theta_diag*N*mi_n*sin_theta_diag*cos_theta_diag*e+l*cos_theta_diag*N*mi_n*cos_theta_diag*cos_theta_diag*e;

K1=(-M11*e'*mi_n*sin_theta_diag*sin_theta_diag+M12*e'*mi_n*sin_theta_diag*cos_theta_diag)*K*sin_theta_diag...
    -(M11*e'*mi_n*sin_theta_diag*cos_theta_diag-M12*e'*mi_n*cos_theta_diag*cos_theta_diag)*K*cos_theta_diag;
 
K2=(-M11*e'*mi_n*sin_theta_diag*sin_theta_diag+M12*e'*mi_n*sin_theta_diag*cos_theta_diag)*K*cos_theta_diag...
    +(M11*e'*mi_n*sin_theta_diag*cos_theta_diag-M12*e'*mi_n*cos_theta_diag*cos_theta_diag)*K*sin_theta_diag;

K3=M11*e'*mi_n*sin_theta_diag*cos_theta_diag*V_x_a-M12*e'*mi_n*cos_theta_diag*cos_theta_diag*V_x_a...
    +M11*e'*mi_n*sin_theta_diag*sin_theta_diag*V_y_a-M12*e'*mi_n*sin_theta_diag*cos_theta_diag*V_y_a;

K4=(-M21*e'*mi_n*sin_theta_diag*sin_theta_diag+M22*e'*mi_n*sin_theta_diag*cos_theta_diag)*K*sin_theta_diag...
    -(M21*e'*mi_n*sin_theta_diag*cos_theta_diag-M22*e'*mi_n*cos_theta_diag*cos_theta_diag)*K*cos_theta_diag;
 

K5=(-M21*e'*mi_n*sin_theta_diag*sin_theta_diag+M22*e'*mi_n*sin_theta_diag*cos_theta_diag)*K*cos_theta_diag...
    +(M21*e'*mi_n*sin_theta_diag*cos_theta_diag-M22*e'*mi_n*cos_theta_diag*cos_theta_diag)*K*sin_theta_diag;

K6=M21*e'*mi_n*sin_theta_diag*cos_theta_diag*V_x_a-M22*e'*mi_n*cos_theta_diag*cos_theta_diag*V_x_a...
    +M21*e'*mi_n*sin_theta_diag*sin_theta_diag*V_y_a-M22*e'*mi_n*sin_theta_diag*cos_theta_diag*V_y_a;

K_sx=l*sin_theta_diag*A'*((D*D')\D)*(m+mi_n*sin_theta_diag*sin_theta_diag)*e;
K_sy=l*sin_theta_diag*A'*((D*D')\D)*(-mi_n*sin_theta_diag*cos_theta_diag)*e;
K_cx=l*cos_theta_diag*A'*((D*D')\D)*(mi_n*sin_theta_diag*cos_theta_diag)*e;
K_cy=l*cos_theta_diag*A'*((D*D')\D)*(-m-mi_n*cos_theta_diag*cos_theta_diag)*e;

% Calculates the inertia matrix

% M=J+l*sin_theta_diag*V*sin_theta_diag+l*cos_theta_diag*V*cos_theta_diag...
%     +lambda1+sin_theta_diag*A_1*(sin_theta_diag*sin_theta_diag*K*sin_theta_diag+sin_theta_diag*cos_theta_diag*K*cos_theta_diag)...
%     -cos_theta_diag*A_1*(-sin_theta_diag*cos_theta_diag*K*sin_theta_diag-cos_theta_diag*cos_theta_diag*K*cos_theta_diag)...
%     +(K_sx+K_cx)*(-M11*e'*mi_n*(sin_theta_diag*sin_theta_diag*K*sin_theta_diag+sin_theta_diag*cos_theta_diag*K*cos_theta_diag)...
%     -M12*e'*mi_n*(-sin_theta_diag*cos_theta_diag*K*sin_theta_diag+cos_theta_diag*cos_theta_diag*K*cos_theta_diag))...
%     +(K_sy+K_cy)*(-M21*e'*mi_n*(sin_theta_diag*sin_theta_diag*K*sin_theta_diag+sin_theta_diag*cos_theta_diag*K*cos_theta_diag)...
%     -M22*e'*mi_n*(-sin_theta_diag*cos_theta_diag*K*sin_theta_diag+cos_theta_diag*cos_theta_diag*K*cos_theta_diag));
M=J+l*sin_theta_diag*V*sin_theta_diag+l*cos_theta_diag*V*cos_theta_diag...
    +lambda1+sin_theta_diag*A_1*(sin_theta_diag*sin_theta_diag*K*sin_theta_diag+sin_theta_diag*cos_theta_diag*K*cos_theta_diag)...
    -cos_theta_diag*A_1*(-sin_theta_diag*cos_theta_diag*K*sin_theta_diag-cos_theta_diag*cos_theta_diag*K*cos_theta_diag)...
    +(K_sx+K_cx)*K1...
    +(K_sy+K_cy)*K4;


% Calculates various other matrices

% W = l*sin_theta_diag*V*sin_theta_diag-l*cos_theta_diag*V*sin_theta_diag...
%     +sin_theta_diag*A_1*(sin_theta_diag*sin_theta_diag*K*sin_theta_diag-sin_theta_diag*cos_theta_diag*K*sin_theta_diag)...
%     -cos_theta_diag*A_1*(cos_theta_diag*cos_theta_diag*K*sin_theta_diag-sin_theta_diag*cos_theta_diag*K*cos_theta_diag)...
%     +(K_sx+K_cx)*(-M11*e'*mi_n*(sin_theta_diag*sin_theta_diag*K*sin_theta_diag-sin_theta_diag*cos_theta_diag*K*cos_theta_diag)...
%     -M12*e'*mi_n*(-sin_theta_diag*cos_theta_diag*K*sin_theta_diag+cos_theta_diag*cos_theta_diag*K*cos_theta_diag))...
%     +(K_sy+K_cy)*(-M21*e'*mi_n*(sin_theta_diag*sin_theta_diag*K*sin_theta_diag-sin_theta_diag*cos_theta_diag*K*cos_theta_diag)...
%     -M22*e'*mi_n*(-sin_theta_diag*cos_theta_diag*K*sin_theta_diag+cos_theta_diag*cos_theta_diag*K*cos_theta_diag));
W = l*sin_theta_diag*V*cos_theta_diag-l*cos_theta_diag*V*sin_theta_diag...
    +sin_theta_diag*A_1*(sin_theta_diag*sin_theta_diag*K*sin_theta_diag-sin_theta_diag*cos_theta_diag*K*sin_theta_diag)...
    -cos_theta_diag*A_1*(cos_theta_diag*cos_theta_diag*K*sin_theta_diag-sin_theta_diag*cos_theta_diag*K*cos_theta_diag)...
    +(K_sx+K_cx)*K2...
    +(K_sy+K_cy)*K5;

% 
% V_theta=lambda2+sin_theta_diag*A_1*(-sin_theta_diag*cos_theta_diag*V_x_a-sin_theta_diag*sin_theta_diag*V_y_a)...
%     -cos_theta_diag*A_1*(cos_theta_diag*cos_theta_diag*V_x_a+sin_theta_diag*cos_theta_diag*V_y_a)...
%     +(K_sx+K_cx)*(-M11*e'*mi_n*(-sin_theta_diag*cos_theta_diag*V_x_a-sin_theta_diag*sin_theta_diag*V_y_a)...
%     -M12*e'*mi_n*(cos_theta_diag*cos_theta_diag*V_x_a+sin_theta_diag*cos_theta_diag*V_y_a))...
%     +(K_sy+K_cy)*(-M21*e'*mi_n*(-sin_theta_diag*cos_theta_diag*V_x_a-sin_theta_diag*sin_theta_diag*V_y_a)...
%     -M22*e'*mi_n*(cos_theta_diag*cos_theta_diag*V_x_a+sin_theta_diag*cos_theta_diag*V_y_a));

V_theta=lambda2+sin_theta_diag*A_1*(-sin_theta_diag*cos_theta_diag*V_x_a-sin_theta_diag*sin_theta_diag*V_y_a)...
    -cos_theta_diag*A_1*(cos_theta_diag*cos_theta_diag*V_x_a+sin_theta_diag*cos_theta_diag*V_y_a)...
    +(K_sx+K_cx)*K3...
    +(K_sy+K_cy)*K6;

K_x=-l*sin_theta_diag*A'*((D*D')\D)+(K_sx+K_cx)*M11*e'+(K_sy+K_cy)*M21*e';
K_y=l*cos_theta_diag*A'*((D*D')\D)+(K_sx+K_cx)*M12*e'+(K_sy+K_cy)*M22*e';
    

% Calculates a vector of squared angular link velocities
theta_dot_sq = zeros(n, 1);
theta_dot_abs = zeros(n, 1);

for i = 1:n
    theta_dot_sq(i, 1) = theta_dot(i, 1)*theta_dot(i, 1);
    theta_dot_abs(i, 1) = theta_dot(i, 1)*abs(theta_dot(i, 1));
end

% Constructs the inertia matrix of the system

M_inv=M\eye(n);
% if qw>200
% stoo
% end
% qw=qw+1;
% Calculates a matrix related to Coriolis and centripetal forces
W_th=W*theta_dot_sq+V_theta*theta_dot+lambda3*theta_dot_abs...
    +K_x*(fx+fxt)+K_y*(fy+fyt);

% Calculates the theta_dot_dot
theta_dot_dot =M_inv*(D'*u-W_th+tau_t);


px_dot_dot=K1*theta_dot_dot+K2*theta_dot_sq+K3*theta_dot+M11*e'*(fx+fxt)+M12*e'*(fy+fyt);
py_dot_dot=K4*theta_dot_dot+K5*theta_dot_sq+K6*theta_dot+M21*e'*(fx+fxt)+M22*e'*(fy+fyt);

p_CM_dot_dot=[px_dot_dot;py_dot_dot];

%teller=[teller;M(1)];
t_save=[t_save;t];
%zfsd=-lambda1*theta_dot_dot-lambda2*theta_dot-lambda3*theta_dot_abs
% Calculates the joint angle acceleration
phi_dot_dot=D*theta_dot_dot;