function [u, phi_ref] = calculate_u_lateral_undulation(t, phi, phi_dot, theta, p_CM, p_CM_dot)
%
% Calculates and returns the actuator forces. This is the joint controller
% of the snake robot.
%

global n Kp_joint Kd_joint alpha omega delta

phi_offset = 0;

% Calculates references for joint angles.
phi_ref = zeros(n-1, 1);
for i = 1:n-1
    phi_ref(i, 1) = alpha*sin(omega*t + (i-1)*delta) - phi_offset;
end

% Calculates references for joint velocities.
phi_ref_d = zeros(n-1, 1);
for i = 1:n-1
    phi_ref_d(i, 1) = alpha*omega*cos(omega*t + (i-1)*delta);
end
% Calculates references for joint accelerations.
phi_ref_dd = zeros(n-1, 1);
for i = 1:n-1
    phi_ref_dd(i, 1) = -alpha*omega^2*sin(omega*t + (i-1)*delta);
end

% Calculates the actuator forces.
u = zeros(n-1, 1);
for i = 1:n-1
    error = phi_ref(i, 1) - phi(i, 1);
    error_d = phi_ref_d(i, 1) - phi_dot(i, 1);
    %u(i, 1) = Kp_joint*error - Kd_joint*phi_dot(i, 1);
    u(i, 1) = phi_ref_dd(i, 1) + Kd_joint*error_d + Kp_joint*error;
end
